/* Eirik's Miscellaneous Modified NetBeans Libraries.
   Written or modified (as noted) by Eirik Bakke 2013-2016, ebakke@alum.mit.edu. */

package com.sieuferd.upstream;

import java.net.URL;
import javax.swing.ImageIcon;
import org.openide.util.ImageUtilities;

public final class UpstreamUtil {
  private UpstreamUtil() { }

  public static final boolean USE_CUSTOM_LOADIMAGEICON = false;

  /* TODO[pd]: Remove this once ImageUtilities.loadImageIcon is updated to support retina icons. See
               https://netbeans.org/bugzilla/show_bug.cgi?id=239745 . */
  // Alternative to ImageUtilities.loadImageIcon that supports @2x icons.
  public static final ImageIcon loadImageIcon(String resource) {
    if (USE_CUSTOM_LOADIMAGEICON) {
      final ClassLoader loader = Thread.currentThread().getContextClassLoader();
      final URL url = loader.getResource(resource);
      if (url == null)
        return null;
      return new ImageIcon(url);
    } else {
      return ImageUtilities.loadImageIcon(resource, false);
    }
  }
}
