/* Eirik's Miscellaneous Modified NetBeans Libraries.
   Written or modified (as noted) by Eirik Bakke 2013-2016, ebakke@alum.mit.edu. I elect to include
   this software in this distribution under the GPL Version 2 (with Classpath Exception) license. */

/* This file is based on:
 *   org.netbeans.swing.plaf.aqua.AquaSeparatorUI
 *     (with listed author Christopher Atlan)
 * The complete license header for the original file is listed below.
 */
/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2010 Oracle and/or its affiliates. All rights reserved.
 *
 * Oracle and Java are registered trademarks of Oracle and/or its affiliates.
 * Other names may be trademarks of their respective owners.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */
package com.sieuferd.upstream.laf;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import javax.swing.JComponent;
import javax.swing.JSeparator;
import javax.swing.plaf.ComponentUI;
import javax.swing.plaf.SeparatorUI;

/* Copy the original AquaSeparatorUI class verbatim, except to change lineColorVertical to be the
same as lineColorHorizontal. */
public class AquaSeparatorUI2 extends SeparatorUI {
  private static final Color lineColorHorizontal = new Color(215, 215, 215);
  // Old value: new Color(128, 128, 128);
  private static final Color lineColorVertical = new Color(215, 215, 215);
  private static final ComponentUI separatorui = new AquaSeparatorUI2();

  public static ComponentUI createUI(JComponent c) {
    return separatorui;
  }

  @Override
  public void paint(Graphics g, JComponent c) {
    Dimension s = c.getSize();

    if (((JSeparator) c).getOrientation() == JSeparator.HORIZONTAL) {
      g.setColor(lineColorHorizontal);
      g.drawLine(1, 5, s.width - 2, 5);
    } else {
      g.setColor(lineColorVertical);
      g.drawLine(0, 1, 0, s.height - 2);
    }
  }

  @Override
  public Dimension getPreferredSize(JComponent c) {
    if (((JSeparator) c).getOrientation() == JSeparator.HORIZONTAL) {
      return new Dimension(0, 12);
    } else {
      return new Dimension(1, 11);
    }
  }

  @Override
  public Dimension getMinimumSize(JComponent c) {
    return null;
  }

  @Override
  public Dimension getMaximumSize(JComponent c) {
    return null;
  }
}
