/* Eirik's Miscellaneous Swing Utilities.
   Written by Eirik Bakke 2013-2016, ebakke@alum.mit.edu. */

package com.sieuferd.uiutil.api;

import java.awt.event.KeyEvent;
import javax.swing.JComponent;
import javax.swing.KeyStroke;

// This interface exists mainly to unify the convention and documentation for keystroke forwarding.
public interface KeyStrokeForwardable {
  /**
   * Forward a keystroke that was unhandled in one component to another compoent. The parameters and
   * return value are as for
   * {@link javax.swing.JComponent#processKeyBinding(KeyStroke,KeyEvent,int,boolean)}. It is up to
   * the implementation to decide on the relevant {@code InputMap} condition (e.g.
   * {@link JComponent#WHEN_FOCUSED} or {@link JComponent#WHEN_ANCESTOR_OF_FOCUSED_COMPONENT}) to
   * use in the target component, thus there is no {@code condition} parameter here.
   */
  public boolean forwardUnhandledKeyStroke(KeyStroke ks, KeyEvent evt, boolean pressed);
}
