// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.cell.styles;

import com.google.common.base.Preconditions;
import javax.swing.SwingConstants;
import org.openide.util.NbBundle;

@NbBundle.Messages({
  "ENU_HorizontalAlignment_Left=Left",
  "ENU_HorizontalAlignment_Center=Center",
  "ENU_HorizontalAlignment_Right=Right"
})
public enum HorizontalAlignment {
  LEFT(Bundle.ENU_HorizontalAlignment_Left(), SwingConstants.LEFT),
  CENTER(Bundle.ENU_HorizontalAlignment_Center(), SwingConstants.CENTER),
  RIGHT(Bundle.ENU_HorizontalAlignment_Right(), SwingConstants.RIGHT);

  private final String presentationString;
  private final int swingConstant;

  private HorizontalAlignment(String presentationString, int swingConstant) {
    Preconditions.checkNotNull(presentationString);
    this.presentationString = presentationString;
    this.swingConstant = swingConstant;
  }

  @Override
  public String toString() {
    return presentationString;
  }

  public int getSwingConstant() {
    return swingConstant;
  }
}
