// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.cell.styles;

import com.google.common.base.Preconditions;
import com.sieuferd.cell.support.Coordinates;
import com.sieuferd.cell.support.Pixels;

public final class TextMeasurement {
  private final Coordinates dimensions;
  private final Pixels firstBaselineOffset;

  public TextMeasurement(Coordinates dimensions, Pixels firstBaselineOffset) {
    Preconditions.checkNotNull(dimensions);
    Preconditions.checkNotNull(firstBaselineOffset);
    Preconditions.checkArgument(!firstBaselineOffset.isNegative());
    this.dimensions = dimensions;
    this.firstBaselineOffset = firstBaselineOffset;
  }

  public Coordinates getDimensions() {
    return dimensions;
  }

  public Pixels getFirstBaselineOffset() {
    return firstBaselineOffset;
  }
}
