// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.cell.support;

import com.google.common.base.Preconditions;
import com.sieuferd.util.ObjectReference;

// TODO[cc]: Put this in a private package.
public class HitParameters {
  private final Direction cursorBias;
  private final ObjectReference<BiasedLocation> resultReference = ObjectReference.create();

  public HitParameters(Direction cursorBias) {
    Preconditions.checkNotNull(cursorBias);
    this.cursorBias = cursorBias;
  }

  public Direction getCursorBias() {
    return cursorBias;
  }

  /**
   * Set the hit result. The result should be the hit detected at, or closest to, coordinates
   * (0,0) in the coordinate system of the {@code position} passed to {@code Cell.traverse}.
   */
  public void setResult(BiasedLocation result) {
    resultReference.setValue(result);
  }

  public BiasedLocation getResult() {
    return resultReference.getValue();
  }
}
