// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.datamodel;

import com.sieuferd.datamodel.ViewProperty.AppliesTo;
import org.openide.util.NbBundle;

/** Properties with special significance to the View system. */
public final class SProp extends ViewPropertySet {
  public static final SProp INSTANCE = new SProp();

  @NbBundle.Messages("TIT_Special=Special")
  private SProp() {
    super("sieuferd_special", Bundle.TIT_Special(), null, 0);
  }

  private static <T> ViewProperty<T> create(
      String storageName, AppliesTo appliesTo, ViewPropertyType<T> type)
  {
    return addProperty(INSTANCE, storageName, appliesTo, type, false);
  }

  @NbBundle.Messages("TIT_ViewProperty.CHILD_PATHS=Child Paths")
  public static final ViewProperty<PathList> CHILD_PATHS = create("CHILD_PATHS", AppliesTo.RELATION_ONLY,
      ViewPropertyTypes.createNonpersistableType(PathList.class));
}
