// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.datamodel.proptypes;

import com.google.common.base.Preconditions;
import javax.annotation.Nullable;

public final class Warning {
  @Nullable
  private final Warning.Type type;
  private final String displayMessage;

  public Warning(String displayMessage, @Nullable Warning.Type type) {
    Preconditions.checkNotNull(displayMessage);
    this.displayMessage = displayMessage;
    this.type = type;
  }

  public Warning(String displayMessage) {
    this(displayMessage, null);
  }

  public String getDisplayMessage() {
    return displayMessage;
  }

  @Nullable
  public Type getType() {
    return type;
  }

  @Override
  public String toString() {
    return "Warning(\"" + displayMessage + "\")";
  }

  public enum Type {
    ERROR_IN_REFERENCED_FIELD;
  }
}
