// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.layout;

import com.sieuferd.cell.support.Pixels;
import com.sieuferd.datamodel.ViewProperty;
import com.sieuferd.datamodel.ViewProperty.AppliesTo;
import com.sieuferd.datamodel.ViewPropertySet;
import com.sieuferd.datamodel.ViewPropertyType;
import com.sieuferd.datamodel.ViewPropertyTypes;
import org.openide.util.NbBundle;

public class LEProp extends ViewPropertySet {
  public static final LEProp INSTANCE = new LEProp();

  @NbBundle.Messages("TIT_LayoutEffective=Effective Styles")
  private LEProp() {
    super("sieuferd_layout_effective", Bundle.TIT_LayoutEffective(), null, 450);
  }

  private static <T> ViewProperty<T> create(
      String storageName, AppliesTo appliesTo, ViewPropertyType<T> type)
  {
    return addProperty(INSTANCE, storageName, appliesTo, type, false);
  }

  private static final ViewPropertyType<Pixels> PIXELS_TYPE = ViewPropertyTypes.createNonpersistableType(Pixels.class);

  @NbBundle.Messages("TIT_ViewProperty.EFF_OUTLINE_COLUMN_EXCLUDE=Exclude from Outline Columns (effective)")
  public static final ViewProperty<Boolean> EFF_OUTLINE_COLUMN_EXCLUDE = create("EFF_OUTLINE_COLUMN_EXCLUDE", AppliesTo.ANY, ViewPropertyTypes.BOOLEAN);
  @NbBundle.Messages("TIT_ViewProperty.EFF_LABEL_VISIBLE=Label Visible (effective)")
  public static final ViewProperty<Boolean> EFF_LABEL_VISIBLE = create("EFF_LABEL_VISIBLE", AppliesTo.ANY, ViewPropertyTypes.BOOLEAN);
  @NbBundle.Messages("TIT_ViewProperty.EFF_START_NEW_COLUMN=Start New Column (effective)")
  public static final ViewProperty<Boolean> EFF_START_NEW_COLUMN = create("EFF_START_NEW_COLUMN", AppliesTo.ANY, ViewPropertyTypes.BOOLEAN);
  @NbBundle.Messages("TIT_ViewProperty.EFF_START_NEW_COLUMN_SET=Start New Column Set (effective)")
  public static final ViewProperty<Boolean> EFF_START_NEW_COLUMN_SET = create("EFF_START_NEW_COLUMN_SET", AppliesTo.ANY, ViewPropertyTypes.BOOLEAN);
  @NbBundle.Messages("TIT_ViewProperty.EFF_ALTERNATE_ROW_COLORS=Alternating Row Colors (effective)")
  public static final ViewProperty<Boolean> EFF_ALTERNATE_ROW_COLORS = create("EFF_ALTERNATE_ROW_COLORS", AppliesTo.RELATION_ONLY, ViewPropertyTypes.BOOLEAN);
  @NbBundle.Messages("TIT_ViewProperty.EFF_USE_TABLE=Tabular Layout (effective)")
  public static final ViewProperty<Boolean> EFF_USE_TABLE = create("EFF_USE_TABLE", AppliesTo.RELATION_ONLY, ViewPropertyTypes.BOOLEAN);
  @NbBundle.Messages("TIT_ViewProperty.EFF_USE_VERTICAL_TABLE_HEADER=Vertical Table Header (effective)")
  public static final ViewProperty<Boolean> EFF_USE_VERTICAL_TABLE_HEADER = create("EFF_USE_VERTICAL_TABLE_HEADER", AppliesTo.ANY, ViewPropertyTypes.BOOLEAN);

  @NbBundle.Messages("TIT_ViewProperty.EFF_TABLE_COLUMN_WIDTH=Table Column Width (effective)")
  public static final ViewProperty<Pixels> EFF_TABLE_COLUMN_WIDTH = create("EFF_TABLE_COLUMN_WIDTH", AppliesTo.ANY, PIXELS_TYPE);
  /** Includes border, since different labels in the same tuple may have different border widths. */
  @NbBundle.Messages("TIT_ViewProperty.EFF_OUTLINE_LABEL_WIDTH=Outline Label Width (effective)")
  public static final ViewProperty<Pixels> EFF_OUTLINE_LABEL_WIDTH = create("EFF_OUTLINE_LABEL_WIDTH", AppliesTo.RELATION_ONLY, PIXELS_TYPE);
}
