// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.layout;

import com.sieuferd.cell.support.Points;
import com.sieuferd.datamodel.ViewProperty;
import com.sieuferd.datamodel.ViewProperty.AppliesTo;
import com.sieuferd.datamodel.ViewPropertySet;
import com.sieuferd.datamodel.ViewPropertyType;
import com.sieuferd.datamodel.ViewPropertyTypes;
import org.openide.util.NbBundle;

public final class LHProp extends ViewPropertySet {
  public static final LHProp INSTANCE = new LHProp();

  @NbBundle.Messages("TIT_LayoutHeuristic=Auto-Style Parameters")
  private LHProp() {
    super("sieuferd_layout_heuristic", Bundle.TIT_LayoutHeuristic(), null, 420);
  }

  private static <T> ViewProperty<T> create(
      String storageName, AppliesTo appliesTo, ViewPropertyType<T> type)
  {
    return addProperty(INSTANCE, storageName, appliesTo, type, false);
  }

  /** Does not include border. */
  @NbBundle.Messages("TIT_ViewProperty.OUTLINE_MIN_VALUE_WIDTH=Min. Outline Value Width")
  public static final ViewProperty<Points> OUTLINE_MIN_VALUE_WIDTH = create("OUTLINE_MIN_VALUE_WIDTH", AppliesTo.PRIMITIVE_ONLY, LayoutPropertyTypes.POINTS);
  @NbBundle.Messages("TIT_ViewProperty.OUTLINE_VALUE_SNAP_WIDTH=Outline Value Snap Width")
  public static final ViewProperty<Points> OUTLINE_VALUE_SNAP_WIDTH = create("OUTLINE_VALUE_SNAP_WIDTH", AppliesTo.PRIMITIVE_ONLY, LayoutPropertyTypes.POINTS);
  /** Includes border, since different labels in the same tuple may have different border widths. */
  @NbBundle.Messages("TIT_ViewProperty.OUTLINE_MAX_LABEL_WIDTH=Max. Outline Label Width")
  public static final ViewProperty<Points> OUTLINE_MAX_LABEL_WIDTH = create("OUTLINE_MAX_LABEL_WIDTH", AppliesTo.RELATION_ONLY, LayoutPropertyTypes.POINTS);
  @NbBundle.Messages("TIT_ViewProperty.TABLE_MAX_PRIMITIVE_WIDTH=Max. Primitive Table Column Width")
  public static final ViewProperty<Points> TABLE_MAX_PRIMITIVE_WIDTH = create("TABLE_MAX_PRIMITIVE_WIDTH", AppliesTo.PRIMITIVE_ONLY, LayoutPropertyTypes.POINTS);
  @NbBundle.Messages("TIT_ViewProperty.MAX_COLUMNS=Max. Outline Columns")
  public static final ViewProperty<Integer> MAX_COLUMNS = create("MAX_COLUMNS", AppliesTo.RELATION_ONLY, ViewPropertyTypes.INTEGER);
  @NbBundle.Messages("TIT_ViewProperty.COLUMN_MIN_WIDTH=Min. Outline Column Width")
  public static final ViewProperty<Points> COLUMN_MIN_WIDTH = create("COLUMN_MIN_WIDTH", AppliesTo.RELATION_ONLY, LayoutPropertyTypes.POINTS);
}
