// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.layout;

import com.google.common.base.Preconditions;
import com.sieuferd.datamodel.ViewPropertyTypes.EnumMapping;
import org.openide.util.NbBundle;

@NbBundle.Messages({
  "ENU_VisualizationType_NONE=None",
  "ENU_VisualizationType_COLOR_RANGE=Color Range",
  "ENU_VisualizationType_HORIZONTAL_BARS=Horizontal Bars"
})
public enum VisualizationType implements EnumMapping {
  NONE("none", Bundle.ENU_VisualizationType_NONE()),
  COLOR_RANGE("color_range", Bundle.ENU_VisualizationType_COLOR_RANGE()),
  HORIZONTAL_BARS("horizontal_bars", Bundle.ENU_VisualizationType_HORIZONTAL_BARS());

  private final String presentationString;
  private final String storageName;

  private VisualizationType(String storageName, String presentationString) {
    Preconditions.checkNotNull(storageName);
    Preconditions.checkNotNull(presentationString);
    this.storageName = storageName;
    this.presentationString = presentationString;
  }

  @Override
  public String getStorageName() {
    return storageName;
  }

  @Override
  public String toString() {
    return presentationString;
  }
}