// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.layout;

import com.google.common.base.Preconditions;
import javax.annotation.Nullable;
import org.openide.util.NbBundle;

@NbBundle.Messages({
  "ENU_YesNoAuto_Yes=Yes",
  "ENU_YesNoAuto_No=No",
  "ENU_YesNoAuto_Auto=Auto"
})
public enum YesNoAuto {
  YES(true, Bundle.ENU_YesNoAuto_Yes()),
  NO(false, Bundle.ENU_YesNoAuto_No()),
  AUTO(null, Bundle.ENU_YesNoAuto_Auto());

  private final @Nullable Boolean value;
  private final String presentationString;

  private YesNoAuto(@Nullable Boolean value, String presentationString) {
    Preconditions.checkNotNull(presentationString);
    this.value = value;
    this.presentationString = presentationString;
  }

  public @Nullable Boolean getValue() {
    return value;
  }

  @Override
  public String toString() {
    return presentationString;
  }
}
