// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.layout;

import java.util.regex.Matcher;
import org.junit.Test;
import static org.junit.Assert.*;

public class LayoutPropertyTypesTest {
  private void decimalWithUnitsExpectMatch(String input, String expectValue, String expectUnit) {
    Matcher matcher = LayoutPropertyTypes.DECIMAL_WITH_UNITS_PATTERN.matcher(input);
    assertTrue(matcher.matches());
    assertEquals(expectValue, matcher.group(1));
    assertEquals(expectUnit, matcher.group(2));
  }

  private void decimalWithUnitsExpectMismatch(String input) {
    Matcher matcher = LayoutPropertyTypes.DECIMAL_WITH_UNITS_PATTERN.matcher(input);
    assertFalse(matcher.matches());
  }

  @Test
  public void testRegex() {
    decimalWithUnitsExpectMatch("53", "53", "");
    decimalWithUnitsExpectMatch("5.0pt", "5.0", "pt");
    decimalWithUnitsExpectMatch(" 5.0pt ", " 5.0", "pt");
    decimalWithUnitsExpectMatch(" 5e10pt ", " 5e10", "pt");
    decimalWithUnitsExpectMatch(" 5e10 pt ", " 5e10", "pt");
    decimalWithUnitsExpectMatch("5.0", "5.0", "");
    decimalWithUnitsExpectMatch("  5.0  ", "  5.0", "");
    decimalWithUnitsExpectMatch("  5.0  asdf", "  5.0", "asdf");
    decimalWithUnitsExpectMatch("  5asdf", "  5", "asdf");
    decimalWithUnitsExpectMatch("  5.0eadsf2  P  ", "  5.0eadsf2", "P");
    decimalWithUnitsExpectMismatch("");
    decimalWithUnitsExpectMismatch("eeept");
  }
}
