// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.layout.internal;

import com.google.common.collect.ImmutableList;
import com.google.common.collect.Lists;
import java.util.Arrays;
import java.util.List;
import java.util.Random;
import org.junit.Test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;

public class PartitionAlgorithmTest {
  @Test
  public void testPartitionAlgorithm() {
    // [[1, 1, 2, 4], [2, 6], [2, 3, 1, 1, 1]]
    List<Long> sequence = Arrays.asList(1L, 1L, 2L, 4L, 2L, 6L, 2L, 3L, 1L, 1L, 1L);
    //List<Long> sequence = Arrays.asList(1L, 1L, 1L, 1L, 1L);
    if (false) {
      sequence = Lists.newArrayList();
      System.out.println("Filling");
      Random random = new Random(0);
      for (int i = 0; i < 200; i++)
        sequence.add(Math.round(random.nextDouble() * 1000));
    }
    int noPartitions = 3;
    System.out.println("Partitioning");
    List<List<Long>> res = PartitionAlgorithm.doPartition(sequence, noPartitions,
        new PartitionAlgorithm.ScalarOperations<Long,Long>() {
      @Override
      public Long getValue(Long wrapper) {
        return wrapper;
      }

      @Override
      public boolean greaterThan(Long v1, Long v2) {
        return v1 > v2;
      }

      @Override
      public Long plus(Long v1, Long v2) {
        return v1 + v2;
      }

      @Override
      public Long getZero() {
        return 0L;
      }
    });
    assertThat(res, equalTo((List<List<Long>>) ImmutableList.<List<Long>>of(
          ImmutableList.of(1L, 1L, 2L, 4L),
          ImmutableList.of(2L, 6L),
          ImmutableList.of(2L, 3L, 1L, 1L, 1L)
        )));
    // TODO[te]: Add more tests.
  }
}