// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.query;

import java.util.Objects;
import javax.annotation.Nullable;
import javax.annotation.concurrent.Immutable;

@Immutable
public class InstanceDefinition {
  private final @Nullable TableIdentifier table;

  public InstanceDefinition(@Nullable TableIdentifier table) {
    this.table = table;
  }

  public @Nullable TableIdentifier getTable() {
    return table;
  }

  public interface TableIdentifier {
  }

  @Override
  public int hashCode() {
    return Objects.hash(table);
  }

  @Override
  public boolean equals(Object obj) {
    if (obj == this)
      return true;
    if (!(obj instanceof InstanceDefinition))
      return false;
    InstanceDefinition other = (InstanceDefinition) obj;
    return Objects.equals(this.table, other.table);
  }
}
