// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.viewset;

import java.util.EventObject;

// TODO[cc]: Consider using a regular ChangeEvent instead.

/** Shallowly immutable. */
public final class ViewSetEvent extends EventObject {
  private final GatedView view;
  private final boolean added;

  public ViewSetEvent(ViewSet source, GatedView view, boolean added) {
    super(source);
    this.view = view;
    this.added = added;
  }

  @Override
  public ViewSet getSource() {
    return (ViewSet) super.getSource();
  }

  public GatedView getView() {
    return view;
  }

  /** @return true if added, false if removed. */
  public boolean isAdded() {
    return added;
  }
}
