// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project;

import com.sieuferd.uiutil.UIUtil;
import java.awt.Frame;
import java.awt.GraphicsEnvironment;
import javax.swing.JFrame;
import org.openide.modules.ModuleInstall;
import org.openide.util.Mutex;
import org.openide.windows.WindowManager;

public class Installer extends ModuleInstall {
  private static final boolean SMALL_WINDOW_DECORATION = false;

  @Override
  public void validate() throws IllegalStateException {
    /* Attempt to do this as early as possible while still keeping the call to registerFont and the
    first call to SieuferdIcons.getIconFont() on the EDT. */
    Mutex.EVENT.readAccess((Mutex.Action<Void>) () -> {
      GraphicsEnvironment.getLocalGraphicsEnvironment().registerFont(SieuferdIcons.getIconFont());
      return null;
    });
  }

  @Override
  public void restored() {
    if (SMALL_WINDOW_DECORATION && UIUtil.isAqua()) {
      Mutex.EVENT.readAccess((Mutex.Action<Void>) () -> {
        Frame mainWindow = WindowManager.getDefault().getMainWindow();
        if (mainWindow instanceof JFrame)
          ((JFrame) mainWindow).getRootPane().putClientProperty("Window.style", "small");
        return null;
      });
    }
  }
}
