// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project;

import java.io.IOException;
import java.util.logging.Logger;
import org.netbeans.api.project.Project;
import org.netbeans.api.project.ProjectManager.Result;
import org.netbeans.spi.project.ProjectFactory;
import org.netbeans.spi.project.ProjectFactory2;
import org.netbeans.spi.project.ProjectState;
import org.openide.filesystems.FileObject;
import org.openide.util.lookup.ServiceProvider;

// See AntBasedProjectFactorySingleton.
// The service provider must be ProjectFactory, not ProjectFactory2.
@ServiceProvider(service=ProjectFactory.class)
public class SieuferdProjectFactory implements ProjectFactory2 {
  private static final Logger LOG = Logger.getLogger(SieuferdProjectFactory.class.getName());

  @Override
  public boolean isProject(FileObject projectDirectory) {
    return SieuferdProject.isProject(projectDirectory);
  }

  @Override
  public Result isProject2(FileObject projectDirectory) {
    // See NbMavenProjectFactory.isProject2().
    if (isProject(projectDirectory)) {
      return new Result(SieuferdProjectInformation.getIconStatic());
    } else {
      return null;
    }
  }

  @Override
  public Project loadProject(FileObject projectDirectory, ProjectState state) throws IOException {
    return SieuferdProject.loadProject(projectDirectory, state);
  }

  @Override
  public void saveProject(Project project) throws IOException, ClassCastException {
    LOG.info("SieuferdProjectFactory.saveProject() called");
  }
}
