// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.actions;

import com.google.common.base.Preconditions;
import com.sieuferd.project.toolbox.FieldsTabPanel;
import com.sieuferd.uiutil.UIUtil;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import org.openide.awt.ActionID;
import org.openide.awt.ActionReference;
import org.openide.awt.ActionReferences;
import org.openide.awt.ActionRegistration;
import org.openide.util.NbBundle.Messages;

@ActionID(category = "Sieuferd", id = "com.sieuferd.actionids.FieldsAction")
@ActionRegistration(displayName = "#CTL_FieldsAction")
@ActionReferences({
  @ActionReference(path = "Sieuferd/FieldContextMenu", position = 1100, separatorBefore = 1000),
  @ActionReference(path = "Keymaps/NetBeans", name = "D-K")
})
// Ampersand followed by space will not be interpreted as mnemonic; see Actions.cutAmpersand.
@Messages("CTL_FieldsAction=Fields & Joins...")
public class FieldsAction implements ActionListener {
  private final ToolboxInvoker invoker;

  public FieldsAction(ToolboxInvoker invoker) {
    Preconditions.checkNotNull(invoker);
    this.invoker = invoker;
  }

  @Override
  public void actionPerformed(ActionEvent e) {
    UIUtil.instrumentation("FieldsAction");
    invoker.invoke(FieldsTabPanel.class);
  }
}
