// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.actions;

import com.google.common.base.Preconditions;
import com.sieuferd.project.toolbox.FilterTabPanel;
import com.sieuferd.uiutil.UIUtil;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import org.openide.awt.ActionID;
import org.openide.awt.ActionReference;
import org.openide.awt.ActionReferences;
import org.openide.awt.ActionRegistration;
import org.openide.util.NbBundle.Messages;

@ActionID(category = "Sieuferd", id = "com.sieuferd.actionids.FilterAction")
@ActionRegistration(displayName = "#CTL_FilterAction",
    iconBase = "com/sieuferd/project/icons/badge_filter.png")
@ActionReferences({
  @ActionReference(path = "Sieuferd/FieldContextMenu", position = 3100, separatorBefore = 3000),
  @ActionReference(path = "Keymaps/NetBeans", name = "D-L")
})
@Messages("CTL_FilterAction=Filter...")
public final class FilterAction implements ActionListener {
  private final ToolboxInvoker invoker;

  public FilterAction(ToolboxInvoker invoker) {
    Preconditions.checkNotNull(invoker);
    this.invoker = invoker;
  }

  @Override
  public void actionPerformed(ActionEvent e) {
    UIUtil.instrumentation("FilterAction");
    invoker.invoke(FilterTabPanel.class);
  }
}