// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.actions;

import com.sieuferd.datamodel.MutableView;
import com.sieuferd.datamodel.ViewProperty.AppliesTo;
import com.sieuferd.project.FieldContext;
import com.sieuferd.project.util.FieldSelection;
import com.sieuferd.query.Queries;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;
import org.openide.awt.ActionID;
import org.openide.awt.ActionRegistration;
import org.openide.util.NbBundle;

@ActionID(category = "Sieuferd", id = "com.sieuferd.actionids.GroupAction")
@ActionRegistration(displayName = "#CTL_GroupAction")
//@ActionReference(path = "Sieuferd/FieldContextMenu", position = 4100, separatorBefore = 4000)
@NbBundle.Messages("CTL_GroupAction=Group")
public final class GroupAction implements ActionListener {
  private final List<FieldContext> fieldContexts;

  public GroupAction(List<FieldContext> fieldContexts) {
    this.fieldContexts = fieldContexts;
  }

  @Override
  public void actionPerformed(ActionEvent e) {
    final FieldSelection fieldSelection =
        FieldSelection.fromFieldContexts(fieldContexts, AppliesTo.ANY);
    if (fieldSelection == null)
      return;
    fieldSelection.getViewContext().getView().mutate(Bundle.CTL_GroupAction(), true,
        (MutableView view) ->
    {
      Queries.group(view, fieldSelection.getSelectedPaths());
    });
  }
}
