// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.actions;

import com.sieuferd.datamodel.CProp;
import com.sieuferd.project.util.BooleanViewPropertyAction;
import com.sieuferd.query.QProp;
import javax.swing.Action;
import org.netbeans.api.annotations.common.StaticResource;
import org.openide.awt.ActionID;
import org.openide.awt.ActionReference;
import org.openide.awt.ActionRegistration;
import org.openide.util.NbBundle.Messages;

public final class QuerySettingsActions {
  @StaticResource
  private static final String ICON_PLURAL = "com/sieuferd/project/icons/badge_plural.png";
  @StaticResource
  private static final String ICON_BRACKET = "com/sieuferd/project/icons/badge_bracket.png";
  @StaticResource
  private static final String ICON_PROPFILT = "com/sieuferd/project/icons/badge_propfilt.png";

  private QuerySettingsActions() { }

  @ActionID(category = "Sieuferd", id = "com.sieuferd.actionids.ToggleNestedAction")
  @ActionRegistration(displayName = "#CTL_ToggleNestedAction", lazy = false)
  @ActionReference(path = "Sieuferd/FieldContextMenu", position = 4300)
  @Messages("CTL_ToggleNestedAction=One-to-Many")
  public static Action createToggleNestedAction() {
    return new BooleanViewPropertyAction(Bundle.CTL_ToggleNestedAction(),
        ICON_PLURAL, CProp.PLURAL, false, false);
  }

  @ActionID(category = "Sieuferd", id = "com.sieuferd.actionids.ToggleCollapseDuplicateRowsAction")
  @ActionRegistration(displayName = "#CTL_ToggleCollapseDuplicateRowsAction", lazy = false)
  @ActionReference(path = "Sieuferd/FieldContextMenu", position = 4200)
  @Messages("CTL_ToggleCollapseDuplicateRowsAction=Collapse Duplicate Rows")
  public static Action createToggleCollapseDuplicateRowsAction() {
    return new BooleanViewPropertyAction(Bundle.CTL_ToggleCollapseDuplicateRowsAction(),
        ICON_BRACKET, QProp.INCLUDE_PRIMARY_KEY, true, true);
  }

  @ActionID(category = "Sieuferd", id = "com.sieuferd.actionids.ToggleHideParentIfEmptyAction")
  @ActionRegistration(displayName = "#CTL_ToggleHideParentIfEmptyAction", lazy = false)
  @ActionReference(path = "Sieuferd/FieldContextMenu", position = 3200)
  @Messages("CTL_ToggleHideParentIfEmptyAction=Hide Parent If Empty")
  public static Action createToggleHideParentIfEmptyAction() {
    return new BooleanViewPropertyAction(Bundle.CTL_ToggleHideParentIfEmptyAction(),
        ICON_PROPFILT, QProp.EXISTENTIAL_FILTER, false, true);
  }
}
