// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.actions;

import com.sieuferd.project.SieuferdProjectInformation;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.concurrent.atomic.AtomicLong;
import org.openide.awt.ActionID;
import org.openide.awt.ActionReference;
import org.openide.awt.ActionRegistration;
import org.openide.awt.NotificationDisplayer;
import org.openide.util.ImageUtilities;

@ActionID(category = "Sieuferd/Debug",
    id = "com.sieuferd.actionids.debug.TestNotifierAction")
@ActionRegistration(displayName = "Test Status Bar Notification")
@ActionReference(path = "Keymaps/NetBeans", name = "CS-N")
public class TestNotifierAction implements ActionListener {
  private static final AtomicLong counter = new AtomicLong();

  @Override
  public void actionPerformed(ActionEvent e) {
    NotificationDisplayer.getDefault().notify("Test notification " + counter.incrementAndGet(),
        ImageUtilities.image2Icon(SieuferdProjectInformation.getIconImageStatic()),
        "Details go here", (ActionEvent e1) -> {
          System.out.println("The details were clicked");
    }, NotificationDisplayer.Priority.NORMAL, NotificationDisplayer.Category.INFO);
  }
}
