// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.actions;

import com.sieuferd.datamodel.CProp;
import com.sieuferd.datamodel.MutableView;
import com.sieuferd.datamodel.Path;
import com.sieuferd.project.FieldContext;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import org.openide.awt.ActionID;
import org.openide.awt.ActionRegistration;
import org.openide.util.NbBundle.Messages;

@ActionID(category = "Sieuferd", id = "com.sieuferd.actionids.UnhideAction")
@ActionRegistration(displayName = "#CTL_UnhideAction")
// TODO[pd]: Put this action back in the context menu, or get rid of it entirely.
//@ActionReference(path = "Sieuferd/FieldContextMenu", position = 1300)
@Messages("CTL_UnhideAction=Unhide")
public final class UnhideAction implements ActionListener {
  private final FieldContext fieldContext;

  public UnhideAction(FieldContext fieldContext) {
    this.fieldContext = fieldContext;
  }

  public static String getDisplayName() {
    return Bundle.CTL_UnhideAction();
  }

  @Override
  public void actionPerformed(ActionEvent e) {
    final Path path = fieldContext.getPath();
    fieldContext.getView().mutate(Bundle.CTL_UnhideAction(), true, (MutableView view) -> {
      if (fieldContext.isRelation()) {
        for (Path childPath : view.getChildPaths(path.getRelation()))
          view.set(CProp.VISIBLE, childPath, true);
      } else {
        // Mostly for the Navigator in the single-selection case.
        view.set(CProp.VISIBLE, path, true);
      }
    });
  }
}
