// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.actions.join;

import java.util.List;
import javax.swing.event.ChangeListener;

/** EDT Only. */
public interface ArrowWidgetModel {
  public void addChangeListener(ChangeListener changeListener);
  public void removeChangeListener(ChangeListener changeListener);
  public List<Arrow> getArrows();

  public static final class Arrow {
    /** Y position of the leftmost end of the arrow, in the coordinate space of the ArrowWidget. */
    public final int leftY;
    /** Y position of the rightmost end of the arrow, in the coordinate space of the ArrowWidget. */
    public final int rightY;
    public final boolean selected;

    public Arrow(int leftY, int rightY, boolean selected) {
      this.leftY = leftY;
      this.rightY = rightY;
      this.selected = selected;
    }
  }
}
