// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.actions.join;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.Rectangle;
import javax.annotation.Nullable;
import javax.swing.JList;
import javax.swing.SwingUtilities;
import org.openide.explorer.view.ListView;

public class ListViewEx extends ListView {
  public void applyOversizeViewport() {
    list.setPreferredSize(null);
    Dimension basePreferred = list.getPreferredSize();
    if (basePreferred == null)
      basePreferred = new Dimension(0, 0);
    Rectangle firstCellBounds = getCellBounds(0, 0);
    final int rowHeight = (firstCellBounds == null) ? 0 : firstCellBounds.height;
    list.setPreferredSize(new Dimension(
        basePreferred.width,
        basePreferred.height + getViewport().getSize().height - rowHeight
    ));
  }

  public @Nullable Rectangle getCellBounds(int index0, int index1) {
    Rectangle ret = list.getCellBounds(index0, index1);
    return ret == null ? null : SwingUtilities.convertRectangle(list, ret, this);
  }

  public void scrollToBeginning() {
    getViewport().setViewPosition(new Point(0, 0));
  }

  public JList<?> getList() {
    return list;
  }
}
