// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.datasource;

import javax.swing.JComponent;
import com.sieuferd.viewset.SieuferdProjectConfiguration;
import org.netbeans.spi.project.ui.support.ProjectCustomizer;
import org.netbeans.spi.project.ui.support.ProjectCustomizer.Category;
import org.netbeans.spi.project.ui.support.ProjectCustomizer.CompositeCategoryProvider;
import org.openide.util.Lookup;
import org.openide.util.NbBundle;

public class DataSourceCategoryProvider implements CompositeCategoryProvider {
  public static final String DATA_SOURCE_CATEGORY = "DataSource";

  @ProjectCustomizer.CompositeCategoryProvider.Registration(
    projectType = "com-sieuferd-project", position = 10
  )
  public static DataSourceCategoryProvider createDataSourceCategoryProvider() {
    return new DataSourceCategoryProvider();
  }

  @NbBundle.Messages("LBL_Config_DataSource=Data Source")
  @Override
  public Category createCategory(Lookup context) {
    return ProjectCustomizer.Category.create(
        DATA_SOURCE_CATEGORY, Bundle.LBL_Config_DataSource(), null);
  }

  @Override
  public JComponent createComponent(Category category, Lookup context) {
    return new DataSourceCustomizer(context.lookup(SieuferdProjectConfiguration.class));
  }
}
