// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.formulabar;

import javax.annotation.Nullable;
import javax.swing.JEditorPane;

public interface CursorEditorProvider {
  /**
   * Prepare the editor for an edit of the specified type, and return the {@code JEditorPane} to
   * use. The same JEditorPane object must always be returned for each CursorEditType, and each
   * CursorEditType must have a separate JEditorPane object. The CursorEditorProvider must not
   * change the Document or EditorKit of returned JEditorPane objects.
   */
  public @Nullable JEditorPane update(CursorEditType type);
}
