// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.formulabar;

import java.util.Collection;
import java.util.EnumSet;
import org.netbeans.api.lexer.Language;
import org.netbeans.modules.csl.spi.DefaultLanguageConfig;
import org.netbeans.modules.csl.spi.LanguageRegistration;
import org.netbeans.spi.lexer.LanguageHierarchy;
import org.netbeans.spi.lexer.Lexer;
import org.netbeans.spi.lexer.LexerRestartInfo;
import org.openide.util.NbBundle.Messages;

// TODO[cc]: Change the name of this, since it is also used for LabelType.
@LanguageRegistration(mimeType = DataValueLanguageConfig.MIME_TYPE)
public class DataValueLanguageConfig extends DefaultLanguageConfig {
  public static final String MIME_TYPE = "application/sieuferd-datavalue";
  private static final Language<DataValueTokenID> LANGUAGE =
      new LanguageHierarchy<DataValueTokenID>()
  {
    @Override
    protected Collection<DataValueTokenID> createTokenIds() {
      return EnumSet.allOf(DataValueTokenID.class);
    }

    @Override
    protected Lexer<DataValueTokenID> createLexer(LexerRestartInfo<DataValueTokenID> info) {
      return new DataValueLexer(info);
    }

    @Override
    protected String mimeType() {
      return DataValueLanguageConfig.MIME_TYPE;
    }
  }.language();

  @Override
  public Language<DataValueTokenID> getLexerLanguage() {
    return LANGUAGE;
  }

  @Messages("NAME_DataValue=Cell Value")
  @Override
  public String getDisplayName() {
    return Bundle.NAME_DataValue();
  }
}
