// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.formulabar;

import com.google.common.base.Preconditions;
import java.io.IOException;
import org.antlr.v4.runtime.UnbufferedCharStream;
import org.netbeans.spi.lexer.LexerInput;

// TODO[cc]: Get rid of this if I don't end up using it.

/* The ANTLR/NetBeans integration tutorial at
http://wiki.netbeans.org/New_Language_Support_Tutorial_Antlr suggests that CharStream must be
implemented from scratch in order to delegate to LexerInput. Another alternative is to extend
ANTLR's own UnbufferedCharStream, which is designed to allow the nextChar method to be overridden as
its sole point of integration. The downside of this approach is that the LexerInput cannot be kept
at the same position as the ANTLR lexer at all times. I'm not sure whether the latter is actually a
requirement, however, as long as the Lexer implementation does not depend on it. */
public final class DumbLexerInputCharStream extends UnbufferedCharStream {
  private final LexerInput lexerInput;

  public DumbLexerInputCharStream(LexerInput lexerInput) {
    // This superclass constructor is used when overriding nextChar().
    super();
    Preconditions.checkNotNull(lexerInput);
    this.lexerInput = lexerInput;
  }

  @Override
  protected int nextChar() throws IOException {
    final int ret = lexerInput.read();
    return (ret == LexerInput.EOF)
        ? -1 // Adhere to the same contract as java.io.Reader.read()
        : ret;
  }

  /* TODO[pd]: Consider implementing getSourceName. The existence of CharStream.UNKNOWN_SOURCE_NAME
               suggests it shouldn't return null. */
}
