// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.formulabar;

import org.netbeans.api.editor.mimelookup.MimeRegistration;
import org.netbeans.spi.editor.highlighting.HighlightsLayer;
import org.netbeans.spi.editor.highlighting.HighlightsLayerFactory;
import org.netbeans.spi.editor.highlighting.ZOrder;

@MimeRegistration(
    mimeType=ExpressionLanguageConfig.MIME_TYPE, service = HighlightsLayerFactory.class)
public class ExpressionHighlightsLayerFactory implements HighlightsLayerFactory {
  /* Use a modified version of the pattern from
  https://platform.netbeans.org/tutorials/nbm-mark-occurrences.html and
  org.netbeans.modules.java.editor.semantic.HighlightsLayerFactoryImpl . Store the highlighter as
  a property on the Document object, but make the CursorEditManager responsible for initializing
  it. */

  @Override
  public HighlightsLayer[] createLayers(final Context context) {
    ExpressionHighlighter highlighter =
        (ExpressionHighlighter) context.getDocument().getProperty(ExpressionHighlighter.class);
    if (highlighter == null) {
      return new HighlightsLayer[] {};
    } else {
      return new HighlightsLayer[] {
        HighlightsLayer.create(
            ExpressionHighlighter.class.getName(),
            // TODO[cc]: Figure out if this is the best ZOrder to use.
            ZOrder.SYNTAX_RACK.forPosition(10),
            true,
            highlighter.getOffsetsBag())
      };
    }
  }
}
