// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.formulabar;

import org.netbeans.api.lexer.Language;
import org.netbeans.modules.csl.spi.DefaultLanguageConfig;
import org.netbeans.modules.csl.spi.LanguageRegistration;
import org.openide.util.NbBundle.Messages;

@LanguageRegistration(mimeType = ExpressionLanguageConfig.MIME_TYPE)
public class ExpressionLanguageConfig extends DefaultLanguageConfig {
  public static final String MIME_TYPE = "application/sieuferd-expression";
  public static final Language<ExpressionTokenId> LANGUAGE =
      ExpressionLanguageHierarchy.INSTANCE.language();

  @Override
  public Language<ExpressionTokenId> getLexerLanguage() {
    return LANGUAGE;
  }

  @Messages("NAME_Expression=Formula Expression")
  @Override
  public String getDisplayName() {
    return Bundle.NAME_Expression();
  }
}
