// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.formulabar;

import com.google.common.collect.ImmutableList;
import java.util.Collection;
import org.netbeans.spi.lexer.LanguageHierarchy;
import org.netbeans.spi.lexer.Lexer;
import org.netbeans.spi.lexer.LexerRestartInfo;

public final class ExpressionLanguageHierarchy extends LanguageHierarchy<ExpressionTokenId> {
  private static final ImmutableList<ExpressionTokenId> TOKEN_IDS =
      ImmutableList.copyOf(ExpressionTokenId.values());
  public static final LanguageHierarchy<ExpressionTokenId> INSTANCE =
      new ExpressionLanguageHierarchy();

  private ExpressionLanguageHierarchy() { }

  @Override
  protected Collection<ExpressionTokenId> createTokenIds() {
    return TOKEN_IDS;
  }

  @Override
  protected Lexer<ExpressionTokenId> createLexer(LexerRestartInfo<ExpressionTokenId> info) {
    return new ExpressionLexer(info);
  }

  @Override
  protected String mimeType() {
    return ExpressionLanguageConfig.MIME_TYPE;
  }
}
