// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.formulabar;

import javax.swing.text.DefaultEditorKit;
import javax.swing.text.Document;
import javax.swing.text.Element;
import javax.swing.text.ViewFactory;
import javax.swing.text.WrappedPlainView;
import javax.swing.undo.UndoManager;
import org.netbeans.api.editor.settings.SimpleValueNames;

// TODO[pd]: Implement.
/**
 * An editor kit for displaying plain text, with some additional features.
 *
 * <p>Line wrapping can be configured by setting the "text-line-wrap" client property
 * {@link SimpleValueNames.TEXT_LINE_WRAP)} on the associated {@code JTextComponent}.
 *
 * <p>Undo/redo can be supported by setting an {@link UndoManager} on the {@link Document}'s
 * "undo-manager" property (from {@link org.netbeans.editor.BaseDocument}).
 */
public class SimpleEditorKit extends DefaultEditorKit {
  @Override
  public ViewFactory getViewFactory() {
    /* In the non-bidirectional case, we can get equivalent functionality to
    JEditorPane$PlainEditorKit by returning a ViewFactory that simply creates a WrappedPlainView
    here. */
    return (Element elem) -> {
      return new WrappedPlainView(elem, true);
    };
  }
}