// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.formulabar.types;

import com.sieuferd.project.formulabar.DataValueLanguageConfig;
import com.sieuferd.project.formulabar.CursorEditKey;
import com.sieuferd.project.formulabar.CursorEditType;
import com.sieuferd.project.formulabar.CursorEditTarget;
import com.sieuferd.util.ObjectReference;
import javax.swing.ImageIcon;

// Don't register as a ServiceProvider; use directly instead.
public final class NoneType extends CursorEditType {
  private static final NoneType INSTANCE = new NoneType();
  public static final CursorEditKey EMPTY_EDIT_KEY = new NoneEditKey();

  private NoneType() {
    /* It would be better to use ImageUtilities.loadImageIcon here, but this approach seems to fail
    when the FormulaBar is loaded by the NetBeans form editor. */
    // ImageUtilities.loadImageIcon(ICON_VALUE, false)
    super(new ImageIcon(NoneType.class.getClassLoader().getResource(ICON_NONE)),
        DataValueLanguageConfig.MIME_TYPE, true);
  }

  @Override
  public CursorEditKey createEditKey(
      CursorEditTarget target, ObjectReference<String> originalValueString)
  {
    originalValueString.setValue("");
    return EMPTY_EDIT_KEY;
  }

  private static final class NoneEditKey extends CursorEditKey {
    public NoneEditKey() {
      super(NoneType.INSTANCE, true);
    }

    // Use default equals/hashCode.
  }
}
