// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.navigator;

import com.sieuferd.project.nodes.FieldNode;
import com.sieuferd.uiutil.SwingString;
import org.openide.awt.HtmlRenderer;

/**
 * A provider for a UI display name in Swing HTML format, to be added to the lookup of a
 * {@link FieldNode}. Can be used when the HTML format supported by NetBeans' {@link HtmlRenderer}
 * is too limiting, for instance to change the font in parts of the displayed string.
 */
public interface SwingStringDisplayNameProvider {
  public SwingString getSwingStringDisplayName();
}
