// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.nodes;

import com.google.common.base.Preconditions;
import com.sieuferd.project.SieuferdProject;
import java.util.List;
import org.openide.nodes.ChildFactory;
import org.openide.nodes.Node;

/* TODO[cc]: Is there an easier way to specify a constant set of nodes? Oh well, eventually I'll be
             implementing more general-purpose folders anyway. */
public class SieuferdProjectChildFactory extends ChildFactory<Boolean> {
  private final SieuferdProject project;
  private final NodeSettings nodeSettings;

  public SieuferdProjectChildFactory(SieuferdProject project, NodeSettings nodeSettings) {
    Preconditions.checkNotNull(project);
    Preconditions.checkNotNull(nodeSettings);
    this.project = project;
    this.nodeSettings = nodeSettings;
  }

  @Override
  protected Node createNodeForKey(Boolean key) {
    return new ViewFolderNode(project, nodeSettings, key);
  }

  @Override
  protected boolean createKeys(List<Boolean> toPopulate) {
    toPopulate.add(true);
    toPopulate.add(false);
    return true;
  }
}
