// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.propertyeditors;

import com.sieuferd.project.formulabar.types.FormulaType;
import com.sieuferd.datamodel.expressions.Expression;
import com.sieuferd.datamodel.Strepco;
import com.sieuferd.datamodel.expressions.Expressions;
import com.sieuferd.util.ObjectReference;
import org.openide.nodes.PropertyEditorRegistration;

@PropertyEditorRegistration(targetType = Expression.class)
public class ExpressionEditor extends ViewPropertyEditor<Expression> {
  @Override
  protected String valueToText(Expression value) {
    final Strepco strepco = getStrepco();
    if (strepco == null)
      return null;
    return Expressions.generateString(strepco, value);
  }

  @Override
  public Expression textToValue(String text) throws IllegalArgumentException {
    final Strepco strepco = getStrepco();
    if (strepco == null)
      throw new IllegalArgumentException("Cannot set formula out of context");
    return FormulaType.parseUserExpression(strepco, text, ObjectReference.<Boolean>create());
  }
}
