// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.propertyeditors;

import com.sieuferd.datamodel.Strepco;
import com.sieuferd.datamodel.ViewPropertyType;

public class GenericViewPropertyEditor<T> extends ViewPropertyEditor<T> {
  @Override
  protected String valueToText(T value) {
    Strepco strepco = getStrepco();
    ViewPropertyType<T> type = getViewPropertyType();
    if (strepco == null || type == null)
      return null;
    return type.valueToString(strepco, value);
  }

  @Override
  protected T textToValue(String text) throws IllegalArgumentException {
    Strepco strepco = getStrepco();
    ViewPropertyType<T> type = getViewPropertyType();
    if (strepco == null || type == null)
      throw new IllegalArgumentException("Context not available; cannot parse value");
    try {
      return type.stringToValue(strepco, text);
    } catch (UnsupportedOperationException e) {
      throw new IllegalArgumentException("Value parsing not supported for this property type");
    }
  }
}
