// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.result;

import com.google.common.base.Preconditions;
import com.sieuferd.datamodel.ImmutableView;

public final class EvaluationInput {
  private final String databaseConnectionName;
  private final ImmutableView querySnapshot;
  private final int limit;

  public EvaluationInput(String databaseConnectionName, ImmutableView querySnapshot, int limit) {
    Preconditions.checkNotNull(querySnapshot);
    Preconditions.checkNotNull(databaseConnectionName);
    Preconditions.checkArgument(limit >= 0);
    this.querySnapshot = querySnapshot;
    this.databaseConnectionName = databaseConnectionName;
    this.limit = limit;
  }

  public String getDatabaseConnectionName() {
    return databaseConnectionName;
  }

  public ImmutableView getQuerySnapshot() {
    return querySnapshot;
  }

  public int getLimit() {
    return limit;
  }
}
