// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.result;

import com.google.common.collect.Maps;
import com.sieuferd.project.formulabar.CursorEditType;
import com.sieuferd.project.formulabar.CursorEditorProvider;
import com.sieuferd.project.formulabar.InplaceEditorImpl;
import java.util.Map;
import javax.annotation.Nullable;
import javax.swing.JEditorPane;

final class InplaceCursorEditorProvider implements CursorEditorProvider {
  private final Map<CursorEditType,InplaceEditorImpl> editorCache = Maps.newLinkedHashMap();
  private @Nullable InplaceEditorImpl inplaceEditor;

  public InplaceCursorEditorProvider() {
  }

  @Override
  public JEditorPane update(CursorEditType type) {
    inplaceEditor = editorCache.get(type);
    if (inplaceEditor == null) {
      inplaceEditor = new InplaceEditorImpl();
      editorCache.put(type, inplaceEditor);
    }
    return inplaceEditor.getEditorPane();
  }

  public @Nullable InplaceEditorImpl getInplaceEditor() {
    return inplaceEditor;
  }
}
