// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.toolbox;

import com.google.common.base.Preconditions;
import com.sieuferd.project.FieldContext;
import com.sieuferd.uiutil.ThreadUtil;
import java.awt.Component;
import java.util.Set;
import org.openide.util.NbBundle.Messages;

@Messages("TIT_FilterTabPanel=Filter")
public final class FilterTabPanel extends ToolboxTab {
  FilterTabPanel() {
    initComponents();
  }

  @Override
  public void setFieldContexts(final Set<FieldContext> fieldContexts) {
    ThreadUtil.checkOnEDT();
    Preconditions.checkNotNull(fieldContexts);
    filterPanel.setFieldContexts(fieldContexts);
  }

  @Override
  public void setOpened(boolean opened) {
    filterPanel.setOpened(opened);
  }

  @Override
  protected Component getDefaultFocusComponent() {
    return filterPanel;
  }

  @Override
  public String getTitle() {
    return Bundle.TIT_FilterTabPanel();
  }

  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {
    java.awt.GridBagConstraints gridBagConstraints;

    filterPanel = new com.sieuferd.project.filter.FilterPanel();

    setOpaque(false);
    setPreferredSize(new java.awt.Dimension(350, 500));
    setLayout(new java.awt.GridBagLayout());

    filterPanel.setOpaque(false);
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 0;
    gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints.gridheight = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
    gridBagConstraints.weightx = 1.0;
    gridBagConstraints.weighty = 1.0;
    add(filterPanel, gridBagConstraints);
  }// </editor-fold>//GEN-END:initComponents


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private com.sieuferd.project.filter.FilterPanel filterPanel;
  // End of variables declaration//GEN-END:variables
}
