// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.toolbox;

import com.google.common.base.Preconditions;
import com.sieuferd.project.FieldContext;
import com.sieuferd.uiutil.api.PopupLike;
import com.sieuferd.uiutil.ThreadUtil;
import java.util.Set;

public final class Toolbox {
  private static Toolbox globalInstance;
  private final ToolboxPanel panel = new ToolboxPanel();

  private Toolbox() { }

  public static Toolbox getGlobalInstance() {
    ThreadUtil.checkOnEDT();
    if (globalInstance == null)
      globalInstance = new Toolbox();
    return globalInstance;
  }

  public void setFieldContexts(final Set<FieldContext> fieldContexts) {
    ThreadUtil.checkOnEDT();
    Preconditions.checkNotNull(fieldContexts);
    panel.setFieldContexts(fieldContexts);
  }

  public PopupLike getPopup() {
    return panel.getPopup();
  }

  public void setActiveTab(Class<? extends ToolboxTab> tabClass) {
    panel.setActiveTab(tabClass);
  }
}
