// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.toolbox;

import java.awt.Component;
import org.netbeans.swing.tabcontrol.TabDisplayer;
import org.netbeans.swing.tabcontrol.WinsysInfoForTabbedContainer;
import org.openide.windows.TopComponent;

/**
 * This class exists purely to provide static configuration for the TabDisplayer used by the
 * toolbox, notably to get rid of "close" buttons in the tabs.
 */
final class ToolboxWinsysInfo extends WinsysInfoForTabbedContainer {
  @Override
  public Object getOrientation(Component comp) {
    return TabDisplayer.ORIENTATION_INVISIBLE;
  }

  @Override
  public boolean inMaximizedMode(Component comp) {
    return false;
  }

  @Override
  public boolean isTopComponentSlidingEnabled() {
    return false;
  }

  @Override
  public boolean isTopComponentClosingEnabled() {
    return false;
  }

  @Override
  public boolean isTopComponentMaximizationEnabled() {
    return false;
  }

  @Override
  public boolean isTopComponentClosingEnabled(TopComponent tc) {
    return false;
  }

  @Override
  public boolean isTopComponentSlidingEnabled(TopComponent tc) {
    return false;
  }

  @Override
  public boolean isTopComponentMaximizationEnabled(TopComponent tc) {
    return false;
  }

  @Override
  public boolean isModeSlidingEnabled() {
    // Needs to be true to avoid "justifying" the tabs.
    return true;
  }

  @Override
  public boolean isSlidedOutContainer() {
    return false;
  }

  @Override
  public boolean isTopComponentBusy(TopComponent tc) {
    return false;
  }
}
