// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.viewfile;

import com.sieuferd.datamodel.ViewProperty;
import com.sieuferd.datamodel.ViewProperty.AppliesTo;
import com.sieuferd.datamodel.ViewPropertySet;
import com.sieuferd.datamodel.ViewPropertyType;
import com.sieuferd.datamodel.ViewPropertyTypes;
import org.openide.util.NbBundle;

public class VSProp extends ViewPropertySet {
  public static final VSProp INSTANCE = new VSProp();

  @NbBundle.Messages("TIT_ViewSet=View Set")
  private VSProp() {
    super("sieuferd_viewset", Bundle.TIT_ViewSet(), null, 0);
  }

  private static <T> ViewProperty<T> create(
      String storageName, AppliesTo appliesTo, ViewPropertyType<T> contentType)
  {
    return addProperty(INSTANCE, storageName, appliesTo, contentType, false);
  }

  private static final ViewPropertyType<ViewIdentifier> VIEW_IDENTIFIER_TYPE =
      ViewPropertyTypes.createNonpersistableType(ViewIdentifier.class);

  @NbBundle.Messages("TIT_ViewProperty.VIEW_IDENTIFIER=View Identifier")
  public static final ViewProperty<ViewIdentifier> VIEW_IDENTIFIER = create("VIEW_IDENTIFIER", AppliesTo.ROOT_ONLY, VIEW_IDENTIFIER_TYPE);
}
