// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project;

import com.google.common.collect.Multimap;
import com.sieuferd.datamodel.ViewProperty;
import com.sieuferd.datamodel.ViewPropertySet;

public final class PrintProperties {
  private PrintProperties() { }

  public static void main(String args[]) {
    final Multimap<ViewPropertySet,ViewProperty<?>> propertiesBySet =
        NBViewSet.VIEW_DEFAULTS.getSortedPropertiesBySet();
    for (ViewPropertySet viewPropertySet : propertiesBySet.keySet()) {
      for (final ViewProperty<?> prop : propertiesBySet.get(viewPropertySet)) {
        System.out.println(
            viewPropertySet.getName()+ "\t" +
            viewPropertySet.getDisplayName() + "\t" +
            prop.getStorageName() + "\t" +
            prop.getDisplayName()+ "\t" +
            prop.getType() + "\t" +
            prop.getAppliesTo()
        );
      }
    }
  }
}
