// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.derivatives;

import com.google.common.collect.ImmutableSet;
import java.util.List;
import org.junit.Assert;
import org.junit.Test;

public class ViewUpdaterTest {
  private static void expectTokens(String identifier, String ... expectedTokens) {
    List<String> actualTerms = ViewUpdater.splitIdentifier(identifier);
    Assert.assertEquals(ImmutableSet.copyOf(expectedTokens), ImmutableSet.copyOf(actualTerms));
  }

  @Test
  public void testSplitIdentifier() {
    expectTokens("");
    expectTokens("hello", "hello");
    expectTokens("hello world", "hello", "world");
    expectTokens("hello_world", "hello", "world");
    expectTokens("helloWorld", "hello", "World");
    expectTokens("hello_World", "hello", "World");
    expectTokens("aBC", "a", "BC");
    expectTokens("foo123-afa", "foo123", "afa");
    expectTokens("foo123-afa-", "foo123", "afa");
    expectTokens("foo123-afa-b", "foo123", "afa", "b");
    expectTokens("foo123-afaB", "foo123", "afa", "B");
    expectTokens("foo123---afaB", "foo123", "afa", "B");
    expectTokens("f%&#&*(@aB", "f", "a", "B");
  }
}


