// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.filter;

import com.google.common.collect.ImmutableSet;
import java.util.List;
import org.junit.Assert;
import org.junit.Test;

public class FilterTest {
  private static void expectSearchTerms(String searchString, String ... expectedTerms) {
    List<String> actualTerms = FilterOptionsQuery.getSearchTerms(searchString);
    Assert.assertEquals(ImmutableSet.copyOf(expectedTerms), ImmutableSet.copyOf(actualTerms));
  }

  @Test
  public void testGetSearchTerms() {
    expectSearchTerms("");
    expectSearchTerms("hello", "hello");
    expectSearchTerms("hello there", "hello", "there");
    expectSearchTerms(" hello there", "hello", "there");
    expectSearchTerms(" hello\nthere", "hello", "there");
    expectSearchTerms(" hello  there", "hello", "there");
    expectSearchTerms(" hello  \"there", "hello", "there");
    expectSearchTerms(" hello  \"there\"", "hello", "there");
    expectSearchTerms(" hello\"there\"", "hello\"there\"");
    expectSearchTerms(" hello \"there\"", "hello", "there");
    expectSearchTerms("hello\"there", "hello\"there");
    expectSearchTerms("hello \"hi\"", "hello", "hi");
    expectSearchTerms("hello \"hi there\"", "hello", "hi there");
    expectSearchTerms("hello \"hi \"\"there\"", "hello", "hi \"there");
  }
}
