// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.project.viewfile;

import java.net.URI;
import java.net.URISyntaxException;
import org.junit.Test;

public class ViewURLComponentsTest {
  private void testReversible(String uriString, String viewIdentifierString)
      throws URISyntaxException
  {
    new ViewURLComponents(new URI(uriString),
        ViewIdentifier.fromStringRepresentation(viewIdentifierString)).toURL();
  }

  @Test
  public void testViewURLComponents() throws URISyntaxException {
    // Rely on the self-check in ViewURLComponents.toURL() to fail here in the case of bugs.
    testReversible("http://www.google.com/asdfdd.asdf", "asdfasdf");
    testReversible("http://www.google.com/", "asdfasdf");
    testReversible("http://www.google.com", "asdfasdf");
    testReversible("http://www.google.com", "");
    testReversible("http://www.google.com/fdHf31$asæødfx", "");
    testReversible("http://www.google.com/fdHf3fx/asd", "");
    testReversible("http://www.google.com/fdHf3fx/asd", "afds/oasd");
    testReversible("http://www.google.com/fdHf3fx/asd", "../");
    testReversible("http://www.google.com/fdHf3fx/asd", "../asdf");
    testReversible("http://www.google.com/fdHf3fx/asd/../", "../asdf");
    testReversible("http://www.google.com/fdHf3fx/asd/../", "ø");
    testReversible("http://www.google.com/fdHf3fx/asd/../", "..");
    testReversible("V:AQLWJ!@:", "ø");
  }
}
