// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.uiutil.flow;

import com.google.common.base.Preconditions;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

final class ChangeBeanFlow<T> extends EDTAdapterFlow<T> {
  private final ChangeBeanAccessor<T> accessor;

  private final ChangeListener propertyChangeListener = (ChangeEvent evt) -> {
    markModelUpdated();
  };

  ChangeBeanFlow(ChangeBeanAccessor<T> accessor) {
    super("ChangeBean");
    Preconditions.checkNotNull(accessor);
    this.accessor = accessor;
  }

  @Override
  protected void addModelListener() {
    accessor.addChangeListener(propertyChangeListener);
  }

  @Override
  protected void removeModelListener() {
    accessor.removeChangeListener(propertyChangeListener);
  }

  @Override
  protected T getModelValue() {
    return accessor.getValue();
  }
}
