// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.uiutil.flow;

import com.google.common.base.Preconditions;
import java.beans.PropertyChangeListener;
import javax.annotation.Nullable;

abstract class PropertyBeanAccessor<T> {
  private final String propertyName;

  public PropertyBeanAccessor(String propertyName) {
    Preconditions.checkNotNull(propertyName);
    this.propertyName = propertyName;
  }

  public final String getPropertyName() {
    return propertyName;
  }

  public abstract void addPropertyChangeListener(PropertyChangeListener listener);
  public abstract void removePropertyChangeListener(PropertyChangeListener listener);

  public abstract @Nullable T getPropertyValue();
}
