// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.uiutil.flow;

import com.sieuferd.flow.Flow;
import java.awt.Component;
import javax.swing.JToggleButton.ToggleButtonModel;
import javax.swing.SingleSelectionModel;
import javax.swing.text.Document;

public class UIModelFlows {
  private UIModelFlows() { }

  public static Flow<String> document(final Document document) {
    return new SwingDocumentFlow(document);
  }

  public static Flow<Boolean> focused(final Component component) {
    return new FocusedFlow(component);
  }

  public static Flow<Boolean> toggleButton(final ToggleButtonModel model) {
    return UIFlows.fromChangeBean(
        (listener) -> { model.addChangeListener(listener); },
        (listener) -> { model.removeChangeListener(listener); },
        () -> model.isSelected());
  }

  public static Flow<Integer> singleSelection(final SingleSelectionModel model) {
    return UIFlows.fromChangeBean(
        (listener) -> { model.addChangeListener(listener); },
        (listener) -> { model.removeChangeListener(listener); },
        () -> model.getSelectedIndex());
  }
}
