// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.uiutil.table;

import java.awt.Component;
import java.util.EventObject;
import javax.annotation.Nullable;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.event.CellEditorListener;
import javax.swing.table.TableCellEditor;

public class NoopTableCellEditor implements TableCellEditor {
  private final JComponent dummyComponent = new JLabel();

  @Override
  public Component getTableCellEditorComponent(
      JTable table, Object value, boolean isSelected, int row, int column)
  {
    return dummyComponent;
  }

  @Override
  public @Nullable Object getCellEditorValue() {
    return null;
  }

  @Override
  public boolean isCellEditable(EventObject anEvent) {
    return false;
  }

  @Override
  public boolean shouldSelectCell(EventObject anEvent) {
    return false;
  }

  @Override
  public boolean stopCellEditing() {
    return true;
  }

  @Override
  public void cancelCellEditing() {
  }

  @Override
  public void addCellEditorListener(CellEditorListener l) {
  }

  @Override
  public void removeCellEditorListener(CellEditorListener l) {
  }
}
