// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.uiutil.table;

import com.google.common.base.Preconditions;
import com.sieuferd.uiutil.SwingString;
import javax.swing.SwingConstants;

public final class StyledTableString {
  private final SwingString whenSelected;
  private final SwingString whenNotSelected;
  private final int horizontalAlignment;

  public StyledTableString(
      SwingString whenSelected, SwingString whenNotSelected, int horizontalAlignment)
  {
    Preconditions.checkNotNull(whenSelected);
    Preconditions.checkNotNull(whenNotSelected);
    Preconditions.checkArgument(
        horizontalAlignment == SwingConstants.LEFT ||
        horizontalAlignment == SwingConstants.CENTER ||
        horizontalAlignment == SwingConstants.RIGHT);
    this.whenSelected = whenSelected;
    this.whenNotSelected = whenNotSelected;
    this.horizontalAlignment = horizontalAlignment;
  }

  public SwingString getString(boolean isSelected) {
    return isSelected ? whenSelected : whenNotSelected;
  }

  public int getHorizontalAlignment() {
    return horizontalAlignment;
  }
}
