// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.widget;

import javax.swing.Scrollable;
import javax.swing.plaf.ComponentUI;
import com.sieuferd.widget.PhysicalCursorMovementAction.CursorDistance;
import com.sieuferd.cell.support.Direction;
import com.sieuferd.uiutil.api.KeyStrokeForwardable;
import com.sieuferd.uiutil.api.PopupLike;
import java.awt.Graphics;
import java.awt.event.KeyEvent;
import javax.swing.JComponent;
import javax.swing.KeyStroke;

public abstract class CellWidgetUI extends ComponentUI implements Scrollable, KeyStrokeForwardable
{
  public abstract void moveCursorPhysical(
      Direction direction, CursorDistance distance, boolean rangeSelect);
  public abstract void moveCursorLogical(Direction direction);

  public abstract void openCursorPopup(PopupLike popup);

  /**
   * Start an inplace edit in extended input mode, and request focus to the inplace editor. If an
   * inplace edit is already in progress, the focus request will still be made, and the input mode
   * will be made extended (see {@link CursorEditInputMap#setExtended(boolean)}).
   */
  public abstract void startInplaceEdit();

  /**
   * Close the inplace editor if open, otherwise perform no action. If the inplace editor previously
   * had the keyboard focus, transfer it back to the main CellWidget.
   */
  public abstract void closeInplaceEditor();

  /**
   * Forward a keystroke that was otherwise unhandled by the {@code CellWidget} to an installed
   * inplace editor, if any.
   */
  @Override
  public abstract boolean forwardUnhandledKeyStroke(KeyStroke ks, KeyEvent evt, boolean pressed);

  public abstract JComponent getFocusComponent();

  public abstract void paintOverlay(Graphics scrollableG);
}
