// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.widget;

import com.sieuferd.cell.support.Coordinates;
import com.sieuferd.cell.support.Location;
import javax.annotation.Nullable;

final class CursorMovement {
  private final @Nullable Location cursorLocation;
  private final @Nullable Coordinates viewportPosition;
  private final @Nullable Coordinates magicCursorPoint;

  /**
   * @param cursorLocation will always be set, but may be null to deselect the cursor
   * @param viewportPosition will be set if not null
   * @param magicCursorPoint will be set if not null
   */
  CursorMovement(@Nullable Location cursorLocation, @Nullable Coordinates viewportPosition,
      @Nullable Coordinates magicCursorPoint)
  {
    this.cursorLocation = cursorLocation;
    this.viewportPosition = viewportPosition;
    this.magicCursorPoint = magicCursorPoint;
  }

  public @Nullable Location getCursorLocation() {
    return cursorLocation;
  }

  public @Nullable Coordinates getViewportPosition() {
    return viewportPosition;
  }

  public @Nullable Coordinates getMagicCursorPoint() {
    return magicCursorPoint;
  }

  public boolean getScrollToCursor() {
    return viewportPosition == null;
  }

  @Override
  public String toString() {
    return "CursorMovement(" +
        cursorLocation + ", " + viewportPosition + ", " + magicCursorPoint + ")";
  }
}
