// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.widget;

import com.google.common.base.Preconditions;
import com.sieuferd.cell.support.Pixels;
import com.sieuferd.cell.support.RenderContext;
import com.sieuferd.datamodel.ViewResult;

public final class LayoutInput {
  private final ViewResult result;
  private final boolean schemaOnly;
  private final Pixels viewportWidth;
  private final RenderContext renderContext;

  public LayoutInput(
      ViewResult result, boolean schemaOnly, Pixels viewportWidth, RenderContext renderContext)
  {
    Preconditions.checkNotNull(result);
    Preconditions.checkNotNull(viewportWidth);
    Preconditions.checkNotNull(renderContext);
    this.result = result;
    this.schemaOnly = schemaOnly;
    this.viewportWidth = viewportWidth;
    this.renderContext = renderContext;
  }

  public ViewResult getResult() {
    return result;
  }

  public boolean isSchemaOnly() {
    return schemaOnly;
  }

  public Pixels getViewportWidth() {
    return viewportWidth;
  }

  public RenderContext getRenderContext() {
    return renderContext;
  }
}
