// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.widget;

import com.google.common.base.Preconditions;
import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.Action;
import com.sieuferd.cell.support.Direction;

public class LogicalCursorMovementAction extends AbstractAction {
  private final Direction direction;

  public LogicalCursorMovementAction(String name, Direction direction) {
    super(name);
    Preconditions.checkNotNull(direction);
    this.direction = direction;
  }

  private String getName() {
    return (String) getValue(Action.NAME);
  }

  @Override
  public String toString() {
    return getName();
  }

  @Override
  public void actionPerformed(ActionEvent e) {
    CellWidget cellWidget = (CellWidget) e.getSource();
    cellWidget.getUI().moveCursorLogical(direction);
  }
}
