// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.widget;

import com.google.common.base.Preconditions;
import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.Action;
import com.sieuferd.cell.support.Direction;

public class PhysicalCursorMovementAction extends AbstractAction {
  private final Direction direction;
  private final CursorDistance distance;
  private final boolean rangeSelect;

  public static enum CursorDistance {
    ONE_CELL,
    ONE_PAGE,
    TO_END
  }

  public PhysicalCursorMovementAction(
      String name, Direction direction, CursorDistance distance, boolean rangeSelect)
  {
    super(name);
    Preconditions.checkNotNull(direction);
    Preconditions.checkNotNull(distance);
    this.direction = direction;
    this.distance = distance;
    this.rangeSelect = rangeSelect;
  }

  private String getName() {
    return (String) getValue(Action.NAME);
  }

  public Direction getDirection() {
    return direction;
  }

  @Override
  public String toString() {
    return getName();
  }

  @Override
  public void actionPerformed(ActionEvent e) {
    CellWidget cellWidget = (CellWidget) e.getSource();
    cellWidget.getUI().moveCursorPhysical(direction, distance, rangeSelect);
  }
}
