// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.csv;

import java.nio.charset.Charset;
import javax.annotation.Nullable;

public final class Config {
  private final char fieldSeparator;
  private final @Nullable Character quote;
  private final @Nullable Charset charset;

  /**
   * @param quote can be null if quoting is not used
   * @param charset can be null, in which case the parser will work in binary mode
   */
  public Config(char fieldSeparator, @Nullable Character quote, @Nullable Charset charset) {
    this.fieldSeparator = fieldSeparator;
    this.quote = quote;
    this.charset = charset;
  }

  public char getFieldSeparator() {
    return fieldSeparator;
  }

  public Character getQuote() {
    return quote;
  }

  public Charset getCharset() {
    return charset;
  }
}
