// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.csv;

import com.google.common.collect.ImmutableList;
import com.sieuferd.csv.Output.WriterOutput;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.Reader;
import java.nio.charset.StandardCharsets;

public final class ParserDriver {
  public static final String FILENAME = "/Users/ebakke/Deletables/ALL_REPORTS.out";

  public static void main(String args[]) throws IOException {
    try (InputStream is = new FileInputStream(FILENAME)) {
      parseCSV(is, new Config(',', '"', null));
    }
  }

  public static void parseCSV(InputStream is, Config config) throws IOException {
    try (Reader reader = new InputStreamReader(is,
        config.getCharset() == null ? StandardCharsets.ISO_8859_1 : config.getCharset()))
    {
      parse(reader, config);
    }
  }

  private static void parse(Reader reader, Config config) throws IOException {
    final WriterOutput output = new WriterOutput(new PrintWriter(System.out));
    Parser parser = new BaseParser(ImmutableList.of(), "");
    int c;
    int i = 0;
    try {
      while ((c = reader.read()) >= 0) {
        //System.out.println(parser.getBranchCount());
        //System.out.print((char) c);
        //System.out.flush();
        parser = parser.advance(config, output, (char) c);
        if (i++ % 100 == 0)
          System.out.println(output.getRowCount());
      }
    } catch (BadParseException e) {
      throw new IOException(e);
    }
    parser.flush(output);
    output.flush();
  }
}
