// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.harness;

import com.sieuferd.database.SQLConnection;
import com.sieuferd.importer.AccessImporter;
import com.sieuferd.query.SQLDatabase;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.DriverManager;
import java.sql.SQLException;

public final class AccessImportDriver {
  private static final String INPUT_FILENAME = "";

  public static final void main(String args[]) throws SQLException, IOException {
    PrintWriter pw = new PrintWriter(System.out, true);
    try (SQLConnection output = new SQLConnection(DriverManager.getConnection(
          "jdbc:postgresql://127.0.0.1:5432/managed", "duser", "dpass")))
    {
      AccessImporter.importFile(new File(INPUT_FILENAME), output, new SQLDatabase("managed", ""),
          pw);
    } catch (SQLException e) {
      SQLException chain = e;
      while ((chain = chain.getNextException()) != null) {
        System.err.println("Chained SQL exception: " + chain.getMessage());
      }
      throw e;
    } finally {
      pw.flush();
    }
  }
}
