// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.database;

import com.sieuferd.database.SQLTask.UserInformedConnectionException;
import java.sql.SQLException;
import javax.annotation.Nonnull;

public abstract class SQLTaskRunner {
  /**
   * Execute the specified task. The task will be run synchronously on the calling thread, at most
   * once.
   */
  public abstract @Nonnull <R> R runTask(
      boolean showDialogOnConnect, boolean testConnection, SQLTask<R> task)
      throws SQLException, UserInformedConnectionException;
}
