// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.database.dialect;

import com.google.common.base.Preconditions;
import javax.annotation.concurrent.Immutable;

@Immutable
public final class ClobSample {
  private final long totalLength;
  private final String sample;

  public ClobSample(long totalLength, String sample) {
    Preconditions.checkArgument(totalLength >= 0);
    Preconditions.checkArgument(totalLength > sample.length());
    this.totalLength = totalLength;
    this.sample = sample;
  }

  @Override
  public String toString() {
    return sample + "... (" + totalLength + " characters total)";
  }
}
