// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.evaluator;

import com.sieuferd.datamodel.CProp;
import com.sieuferd.datamodel.MutableView;
import com.sieuferd.datamodel.Path;
import com.sieuferd.query.Queries;

// TODO[cc]: Move this to Queries.
public final class DataProperties {
  private DataProperties() { }

  public static void configureDataProperties(MutableView toView) {
    configureProjections(toView, Path.ROOT);
    FunctionalDependencies functionalDependencies = new FunctionalDependencies(toView);
    functionalDependencies.configureTupleKeysAndPluralities(toView);
  }

  /** Defines CProp.PROJECTED for all paths. */
  private static void configureProjections(MutableView view, Path path) {
    view.set(CProp.PROJECTED, path, Queries.shouldProject(view, path));
    if (path.isRelation()) {
      for (Path childPath : view.getChildPaths(path.getRelation()))
        configureProjections(view, childPath);
    }
  }
}
