// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.evaluator;

import com.google.common.base.Preconditions;
import com.sieuferd.datamodel.Path.PrimitivePath;
import javax.annotation.concurrent.Immutable;

// TODO[cc]: Consider moving into the common-query module.
@Immutable
public final class OrderedPath {
  private final PrimitivePath path;
  private final boolean descending;
  private final boolean nullsFirst;

  public OrderedPath(PrimitivePath path, boolean descending, boolean nullsFirst) {
    Preconditions.checkNotNull(path);
    this.path = path;
    this.descending = descending;
    this.nullsFirst = nullsFirst;
  }

  public PrimitivePath getPath() {
    return path;
  }

  public boolean isDescending() {
    return descending;
  }

  public boolean isNullsFirst() {
    return nullsFirst;
  }

  public boolean isCollationTotallyOrdered() {
    return true;
  }

  @Override
  public String toString() {
    return path + " " + (descending ? "DESC" : "ASC") + (nullsFirst ? " NULLS FIRST" : "");
  }
}
