// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.evaluator;

import com.google.common.collect.Multimap;
import com.sieuferd.database.SQLConnection;
import com.sieuferd.datamodel.ImmutableData;
import com.sieuferd.datamodel.Path;
import com.sieuferd.datamodel.View;
import com.sieuferd.datamodel.proptypes.Warning;
import com.sieuferd.evaluator.impl.EvaluationSettings;
import com.sieuferd.evaluator.impl.QueryEvaluatorImpl;
import java.io.PrintWriter;
import java.sql.SQLException;
import javax.annotation.Nullable;

public abstract class QueryEvaluator implements AutoCloseable {
  // TODO[pd]: Avoid throwing an exception here.
  @Override
  public abstract void close() throws SQLException;

  /* TODO[cc]: Consider returning a ViewResult instead, and taking a ResultLimit as an argument.
               Then pass the proper limit/warnings around in WidgetMain. */
  public abstract ImmutableData evaluate(int limit, Multimap<Path,Warning> toWarnings);

  public static QueryEvaluator create(View view, SQLConnection connection,
      @Nullable PrintWriter logWriter, CancelHandler cancelHandler)
  {
    return new QueryEvaluatorImpl(
        view, connection, logWriter, cancelHandler, EvaluationSettings.create(true));
  }
}
