// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.evaluator.impl;

import com.google.common.collect.ImmutableSet;
import com.sieuferd.database.SQLFragment;
import java.util.Set;
import javax.annotation.concurrent.Immutable;

// TODO[cc]: Rename.
@Immutable
class GeneratedQuery {
  private final SQLFragment query;
  /* TODO[pd]: Consider making this a map with paths as keys, making it up to the query block to add
               whatever constraints are necessary to produce only a single parameter per path. This
               might require a fair bit of complexity to handle a relatively rare case, however, so
               it might not be worth it. */
  private final ImmutableSet<CorrelationParameter> correlationParameters;

  GeneratedQuery(SQLFragment query, Set<CorrelationParameter> correlationParameters) {
    this.query = query;
    this.correlationParameters = ImmutableSet.copyOf(correlationParameters);
  }

  public SQLFragment getQuery() {
    return query;
  }

  public Set<CorrelationParameter> getCorrelationParameters() {
    return correlationParameters;
  }
}
