// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.evaluator.impl;

import com.google.common.base.Preconditions;
import com.sieuferd.database.SQLFragment;
import javax.annotation.concurrent.Immutable;

/** An entry in a SELECT clause. */
@Immutable
final class SelectPart {
  private final Column column;
  private final SQLFragment expressionFragment;

  /** @param expressionFragment must be of the type indicated by column */
  SelectPart(Column column, SQLFragment expressionFragment) {
    Preconditions.checkNotNull(column);
    Preconditions.checkNotNull(expressionFragment);
    this.column = column;
    this.expressionFragment = expressionFragment;
  }

  public Column getColumn() {
    return column;
  }

  public SQLFragment getExpressionFragment() {
    return expressionFragment;
  }

  @Override
  public String toString() {
    return "SelectedColumn(" + column + ", " + expressionFragment + ")";
  }
}
