// The SIEUFERD project by Eirik Bakke 2010-2016, ebakke@alum.mit.edu.
package com.sieuferd.importer;

import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.net.URLEncoder;

public final class ImportUtil {
  private static final String MANAGED_PREFIX = "sie_";

  private ImportUtil() { }

  public static String encodeHumanIdentifier(String humanIdentifier) {
    try {
      return MANAGED_PREFIX + URLEncoder.encode(humanIdentifier, "UTF-8");
    } catch (UnsupportedEncodingException e) {
      throw new AssertionError(e);
    }
  }

  public static String decodeHumanIdentifier(String identifier) {
    if (!identifier.startsWith(MANAGED_PREFIX))
      return identifier;
    try {
      return URLDecoder.decode(identifier.substring(MANAGED_PREFIX.length()), "UTF-8");
    } catch (UnsupportedEncodingException e) {
      throw new AssertionError(e);
    }
  }
}
